program exercise27
  implicit none

  ! euler法で一階微分方程式を解くプログラム

  ! 実行すると標準出力にx, yが出るためグラフにプロットするには
  ! ./a.out > result.dat
  ! などとしてファイルにリダイレクトする。(a.outはコンパイル時に指定した実行ファイル名)
  ! この場合 result.datに標準出力に出るデータが保存される。

  ! もちろんopen文でファイル名を指定してもよい
   
  real*8 :: x, y, h = 1.0d-1

  ! x=0での初期値y=0を代入
  x = 0.0d0
  y = 0.0d0

  ! 初期値を出力
  print *, x, y

  do
     ! yを1ステップ進める
     y = y + f(x,y)*h

     ! xを1ステップ進める。yより先に進めるとf(x,y)の中のxが更新されてしまうので注意
     x = x + h

     ! 1ステップ進んだ値を出力
     print *, x, y

     ! xが大きくなったらdoループから出る
     if( x .gt. 20.0d0) exit
     
  end do

contains

  ! 一階微分dy/dxを与える関数副プログラム
  
  function f(x,y)
    real*8, intent(in) :: x, y
    real*8 :: f

    f = cos(x)

    return

  end function f
    
  
end program exercise27
